import sys
from omniORB import CORBA, PortableServer
import CosNaming, Example, Example__POA
import threading
import time

class Server(Example__POA.Server, threading.Thread):
    def __init__(self):
        threading.Thread.__init__(self)
        self.callbacs = []

    def run(self):
        i = 0
        while True:
            for callback in self.callbacs:
                try:
                    callback.OnEvent('My message %d' % i)
                except: pass
            i += 1
            print i
            time.sleep(1)

    def SetCallback(self, callback):
        self.callbacs.append(callback)

orb = CORBA.ORB_init(sys.argv, CORBA.ORB_ID)
poa = orb.resolve_initial_references("RootPOA")
poaManager = poa._get_the_POAManager()
poaManager.activate()

server = Server()
obj = orb.resolve_initial_references("NameService")
rootContext = obj._narrow(CosNaming.NamingContext)
name = [CosNaming.NameComponent("CTX", "MY_CTX")]
try:
    context = rootContext.bind_new_context(name)
except CosNaming.NamingContext.AlreadyBound, ex:
    obj = rootContext.resolve(name)
    context = obj._narrow(CosNaming.NamingContext)
name = [CosNaming.NameComponent("Server", "Server")]
try:
    context.bind(name, server._this())
except CosNaming.NamingContext.AlreadyBound:
    context.rebind(name, server._this())
server.start()
