import sys
from omniORB import CORBA, PortableServer
import CosNaming, Example, Example__POA
import threading
import time

class Server(Example__POA.Server, threading.Thread):
    def __init__(self):
        threading.Thread.__init__(self)
        self.callbacs = []

    def run(self):
        i = 0
        while True:
            for callback in self.callbacs[:]:
                try:
                    if callback._non_existent() != 0:
                        print '_non_existent'
                        self.callbacs.remove(callback)
                        continue
                    callback.OnEvent('My message %d' % i)
                except CORBA.TRANSIENT:
                    print 'transient exception'
                    self.callbacs.remove(callback)
                except CORBA.COMM_FAILURE:
                    print 'comm failure'
                    self.callbacs.remove(callback)
                except Exception, e:
                    print e
            i += 1
            # Uncomment this line and the server will become unresponsive
            # after the first callback "dies"
            #time.sleep(1)

    def SetCallback(self, callback):
        print 'SetCallback'
        self.callbacs.append(callback)

orb = CORBA.ORB_init(sys.argv, CORBA.ORB_ID)
poa = orb.resolve_initial_references("RootPOA")
poaManager = poa._get_the_POAManager()
poaManager.activate()

server = Server()
obj = orb.resolve_initial_references("NameService")
rootContext = obj._narrow(CosNaming.NamingContext)
name = [CosNaming.NameComponent("CTX", "MY_CTX")]
try:
    context = rootContext.bind_new_context(name)
except CosNaming.NamingContext.AlreadyBound, ex:
    obj = rootContext.resolve(name)
    context = obj._narrow(CosNaming.NamingContext)
name = [CosNaming.NameComponent("Server", "Server")]
try:
    context.bind(name, server._this())
except CosNaming.NamingContext.AlreadyBound:
    context.rebind(name, server._this())
server.start()
